<?php
/*
 * Developer: Michael Jacky
 * Team site: http://vnextensions.com/
 * Support: http://support.vnextensions.com/
 * 
 */
class Glace_Glacesys_Block_Patch_Instruction extends Glace_Glacesys_Abstract_Adminhtml_Block
{
    /**
     * @var string
     */
    protected $_currentMod;
    
    protected function _construct()
    {
        $this->setTitle('Glace Manual Patch Instructions');
    }
    
    /**
     * @return string
     */
    public function getInstructionsHtml()
    {
        $html = '';
        $incompatibleList  = Mage::getSingleton('adminhtml/session')->getData('glacesys_patch_incompatible_files');
        $this->_currentMod = Mage::app()->getRequest()->getParam('mod');
        
        if (!$this->_currentMod || !isset($incompatibleList[$this->_currentMod])) {
            Mage::app()->getResponse()->setRedirect($this->getUrl('glacesys'));
            return $html;
        }
        foreach ($incompatibleList[$this->_currentMod] as $patchFile) {
            $html .= $this->_getBlockInstruction($patchFile);
        }
        
        return $html;
    }
    
    /**
     * @param array $patchFile
     * @return string
     */
    protected function _getBlockInstruction(array $patchFile)
    {
        $oneBlock = $this->getChild('glacesys.patch.instruction.one');
        $oneBlock->setSourceFile($patchFile['file']);
        $oneBlock->setPatchFile($patchFile['patchfile']);
        $oneBlock->setExtensionPath($patchFile['mod']);
        $oneBlock->setExtensionName($this->_currentMod);
        return $oneBlock->toHtml();
    }
}