<?php
/*
 * Developer: Michael Jacky
 * Team site: http://vnextensions.com/
 * Support: http://support.vnextensions.com/
 * 
 */
class Glace_Glacesys_IndexController extends Mage_Adminhtml_Controller_Action
{
    public function errorAction()
    {
        $this->loadLayout()->_setActiveMenu('system/glacesys');
        $this->renderLayout();
    }
    
    public function indexAction()
    {
        $this->loadLayout()
            ->_setActiveMenu('system/glacesys')
            ->_title(Mage::helper('glacesys')->__('Glace Modules Manager'));
        $this->renderLayout();
    }

    public function saveAction() {
        
        if ($data = $this->getRequest()->getPost('enable')) {
            if ($aErrorList = Mage::getModel('glacesys/glacesys')->saveData($data)) {
                $aModuleList = Mage::getModel('glacesys/glacesys')->getGlaceModuleList();
                
                foreach ($aErrorList as $aError) {
                    $this->_getSession()->addError($aError);
                }
                
                if ($notices = Mage::getModel('glacesys/glacepatch')->getCompatiblityError($aModuleList)) {
                    foreach ($notices as $notice) {
                        $this->_getSession()->addNotice($notice);
                    }
                }
            } else {
                $this->_getSession()->addSuccess(Mage::helper('glacesys')->__('Modules\' settings saved successfully'));
            }
        }
        
        $this->_redirect('*/*');
    }
    
    public function permissionsAction()
    {
        $mode = Mage::app()->getRequest()->getParam('mode');
        
        try {
            Glace_Glacesys_Abstract_Service::get()->filesystem()->permissonsChange($mode);
            Mage::getSingleton('adminhtml/session')->addSuccess(Mage::helper('glacesys')->__('Write permissions were changed successfully'));
            // Glace_Glacesys_Abstract_Service::get()->getCache()->remove('glacesys_db_config'); // removed from 2.20
        } catch (Exception $e) {
            Mage::getSingleton('adminhtml/session')->addError(Mage::helper('glacesys')->__('There was an error while changing write permissions. Permissions were not changed.'));        
        }
        
        $this->_redirect('*/index');
    }
    
    protected function _isAllowed()
    {
        return Mage::getSingleton('admin/session')->isAllowed('system/glacesys');
    }
}