<?php
/*
 * Developer: Michael Jacky
 * Team site: http://vnextensions.com/
 * Support: http://support.vnextensions.com/
 * 
 */

class Glace_Fullpagecache_Block_Adminhtml_EmailsSent extends Glace_Fullpagecache_Block_Adminhtml_EmailsAbstract
{
    protected function _prepareCollection()
    {
        $model = Mage::getModel('fullpagecache/emails');
        $collection = $this->getCollection();
        $currVersion = Mage::getVersion();
        if(version_compare($currVersion, '1.4.2.0', 'ge'))
        {
            $collection->getSelect()->joinLeft(array('coupons'=>$model->getResource()->getTable('salesrule/coupon')), 'main_table.rule_id = coupons.rule_id', array('code'));
        }
        else
        {
            $collection->getSelect()->joinLeft(array('salesrules'=>$model->getResource()->getTable('salesrule/rule')), 'main_table.rule_id = salesrules.rule_id', array('code'=>'coupon_code'));
        }

        $collection->getSelect()->where('sent_at IS NOT NULL');
        return parent::_prepareCollection();
    }

    protected function _prepareColumns()
    {
        parent::_prepareColumns();

        $this->addColumn('sent_at', array(
            'header'    => Mage::helper('fullpagecache')->__('Sent At'),
            'align'     => 'left',
            'width'     => '120px',
            'type'      => 'date',
            'default'   => '--',
            'index'     => 'sent_at',
        ));

        $this->addColumn('code', array(
            'header'    => Mage::helper('fullpagecache')->__('Coupon Code'),
            'align'     => 'left',
            'width'     => '120px',
            'type'      => 'text',
            'index'     => 'code',
        ));

        return $this;
    }

}